//+------------------------------------------------------------------+
//|                                                       PR_LSA.mq4 |
//|                                         Copyright  2010, Candid |
//|                                         http://candid.110mb.com/ |
//+------------------------------------------------------------------+

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Gold
//----
extern double Frame = 1440;
extern int n = 8;
extern int i = 0;
//----
double V[];
double fx[];
double ai[10,10], b[10], x[10], sx[20];
double sum; 
int p, q, f, sName, fs;
double qq, mm, tt;
int ii, jj, kk, ll, nn;
double A[],XC[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() 
  {
   IndicatorShortName("PR_LSA");
   SetIndexStyle(0, DRAW_LINE, 0, 2);
   SetIndexBuffer(0, fx);
   if(fs == 0) 
     {
       sName = CurTime(); 
       fs = 1;
     }
   p = Frame; 
   nn = n + 1; 
   
   ArrayResize(A,nn*(nn+1));
   ArrayResize(XC,nn);
   ArrayResize(V,(Frame+1)*(nn+1));
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |                                                                 |
//+------------------------------------------------------------------+
int deinit() 
  {
  }
//+------------------------------------------------------------------+
//| Custom indicator start function                                  |
//+------------------------------------------------------------------+
int start()
  { 
   for(q = i; q <= i + p; q++) {
     for(kk = n; kk > 0; kk--) {
       int ind = kk+(q-i)*(n+2);
       V[ind] = MathPow(q,kk);
     }
     kk = 0;
     ind = kk+(q-i)*(n+2);
     V[ind] = 1.0;
     kk = n+1;
     ind = kk+(q-i)*(n+2);
     V[ind] = Close[q];
   }
   LSA(V, Frame+1, n+1, A, XC);

   //----
   for(q = i; q <= i + p; q++) 
     {
       sum = 0; 
       for(kk = 1; kk <= n; kk++) 
         {
           sum += XC[kk]*MathPow(q,kk);
         } 
       fx[q]=XC[0]+sum;
     } 
   return(0);
  }
//+------------------------------------------------------------------+

//   
bool Gauss(double& A[], int N, double& X[]) {
// A -  
// N -   A (N,N+1)
int i,j;   //  
int ind,ind1;   //   
int N1 = N+1;
int NN = N*(N+1);
int k,l,m;
double Max;
double tmp,RA;

  for (i=0;i<N;i++) {
    for (k=0;k<=N;k++) {
//      Print("i=",i,", k=",k,", A[i,k]=",A[k+i*N1]);
    }
  }

//  ,   
  for (i=0;i<N-1;i++) {
//        
    j = i;
    Max = 0.0;
    m=i;
    for (k=i;k<N;k++) {
      ind = j+k*N1;
//   ,        
      if (A[ind]>=0.0) tmp = A[ind];
      else tmp = -A[ind];
      if (tmp > Max) {
        Max  = tmp;
        m = k;  //   
      }
    }  //  for (k=i;k<N;k++)
//     ,     
//      
    if (Max == 0.0) {
      Print("  ",j," ");
      return(false);
    }  //  if (Max == 0)
//      ,         
    k = i*N1;  //     
    if (m != i) {
      l = m*N1;
      for (j=i;j<=N;j++) {
        ind1 = j+k;
        ind = j+l;
        tmp = A[ind];
        A[ind] = A[ind1];
        A[ind1] = tmp;
      }  //  for (j=0;j<=N;j++)
    }  //  if (m != i)
//    
    ind1 = i+k;  //      
    RA = 1.0/A[ind1];
    for (l=i+1;l<N;l++) {
//   
      m = l*N1;  //     
      ind = i+m;
      tmp = A[ind]*RA; 
      A[ind] = 0.0;  
      for (j=i+1;j<=N;j++) {
        ind1 = j+k;
        ind = j+m;
        A[ind] = A[ind] - A[ind1]*tmp;
      }  //  for (j=i+1;j<=N;j++)
    }  //  for (l=i+1;l<N;l++)  
  }  //  for (i=0;i<N;i++)
//     
  for (i=N-1;i>=0;i--) {
    k = i*N1;  //     
    tmp = 0.0;
    for (j=i+1;j<N;j++) {
      ind = j+k;
      tmp = tmp + A[ind]*X[j];
    }  //  for (j=i+1;j<N;j++)
    X[i] = (A[N+k]-tmp)/A[i+k]; 
  }  //  for (i=N-1;i>=0;i--)
  return(true);
}
//+------------------------------------------------------------------+
//                                           |
//+------------------------------------------------------------------+
bool LSA(double& V[], int M, int N, double& A[], double& C[]) {
//  N   M
//      Y    M.
//         V[0..M-1][0..N],
//  Y    N 
//        C  M.
//     A[N][N+1]     
  int i,j,k;   //  
  int ind,ind1;   //   
  int ind3,ind4;   //   
  int N1 = N+1;
  int shj,shi,shk;
//   A,    
  shj = -N1;
  for (j=0;j<N;j++) {
    shj = shj+N1;
//    , ,     
    shk = shj;
    for (k=j+1;k<N;k++) {
      ind = k+shj;
      A[ind] = 0.0;
      shi = -N1;
      for (i=0;i<M;i++) {
        shi = shi+N1;
        ind3 = k+shi;
        ind4 = j+shi;
        A[ind] = A[ind] + V[ind3]*V[ind4];
      }  // for (i=j;i<M;i++)
      shk = shk + N1;
      ind1 = j+shk;
      A[ind1] = A[ind];
    }  //  for (k=0;k<N;k++)  //    
//      
    ind = j+shj;
    A[ind] = 0.0;
    ind1 = N+shj;
    A[ind1] = 0.0;
    shi = -N1;
    for (i=0;i<M;i++) {
      shi = shi+N1;
      ind3 = j+shi;
      ind4 = N+shi;
      A[ind] = A[ind] + V[ind3]*V[ind3];
      A[ind1] = A[ind1] + V[ind4]*V[ind3];
    }  //      
  }  //  for (j=0;j<N;j++)  //   
//        
  Gauss(A, N, C);
  return(true);
}

